package kr.co.vividnext.sodalive.can.charge

import kr.co.vividnext.sodalive.can.Can
import kr.co.vividnext.sodalive.can.payment.Payment
import kr.co.vividnext.sodalive.can.use.UseCan
import kr.co.vividnext.sodalive.common.BaseEntity
import kr.co.vividnext.sodalive.member.Member
import javax.persistence.CascadeType
import javax.persistence.Entity
import javax.persistence.EnumType
import javax.persistence.Enumerated
import javax.persistence.FetchType
import javax.persistence.JoinColumn
import javax.persistence.ManyToOne
import javax.persistence.OneToOne

@Entity
data class Charge(
    var chargeCan: Int,
    var rewardCan: Int,
    @Enumerated(value = EnumType.STRING)
    var status: ChargeStatus = ChargeStatus.CHARGE
) : BaseEntity() {
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "can_id", nullable = true)
    var can: Can? = null

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "member_id", nullable = false)
    var member: Member? = null

    @OneToOne(fetch = FetchType.LAZY, cascade = [CascadeType.ALL])
    @JoinColumn(name = "payment_id", nullable = true)
    var payment: Payment? = null
        set(value) {
            value?.charge = this
            field = value
        }

    @OneToOne(fetch = FetchType.LAZY, cascade = [CascadeType.ALL])
    @JoinColumn(name = "use_can_id", nullable = true)
    var useCan: UseCan? = null

    var title: String? = null
}
