package kr.co.vividnext.sodalive.creator.admin.content.category

import org.springframework.beans.factory.annotation.Value
import org.springframework.stereotype.Service

@Service
class CreatorAdminCategoryService(
    private val repository: CreatorAdminCategoryRepository,

    @Value("\${cloud.aws.cloud-front.host}")
    private val imageHost: String
) {
    fun searchContentNotInCategory(
        categoryId: Long,
        searchWord: String,
        memberId: Long
    ): List<SearchContentNotInCategoryResponse> {
        return repository.searchContentNotInCategory(
            categoryId,
            searchWord,
            memberId
        )
    }

    fun getContentInCategory(
        categoryId: Long,
        memberId: Long,
        offset: Long,
        limit: Long
    ): GetContentInCategoryResponse {
        val totalCount = repository.getContentInCategoryTotalCount(categoryId, memberId)
        val items = repository.getContentInCategory(
            imageHost,
            categoryId,
            memberId,
            offset,
            limit
        )

        return GetContentInCategoryResponse(totalCount, items)
    }
}
