package kr.co.vividnext.sodalive.live.room.info

import kr.co.vividnext.sodalive.member.Member

data class LiveRoomMember(
    val id: Long,
    val nickname: String,
    val profileImage: String
) {
    var role = LiveRoomMemberRole.LISTENER

    constructor(member: Member, cloudFrontHost: String) : this(
        id = member.id!!,
        nickname = member.nickname,
        profileImage = if (member.profileImage != null) {
            "$cloudFrontHost/${member.profileImage}"
        } else {
            "$cloudFrontHost/profile/default-profile.png"
        }
    )
}

enum class LiveRoomMemberRole {
    LISTENER, SPEAKER, MANAGER
}
