package kr.co.vividnext.sodalive.member.following

import com.querydsl.jpa.impl.JPAQueryFactory
import kr.co.vividnext.sodalive.member.following.QCreatorFollowing.creatorFollowing
import org.springframework.data.jpa.repository.JpaRepository
import org.springframework.stereotype.Repository

@Repository
interface CreatorFollowingRepository : JpaRepository<CreatorFollowing, Long>, CreatorFollowingQueryRepository

interface CreatorFollowingQueryRepository {
    fun findByCreatorIdAndMemberId(creatorId: Long, memberId: Long): CreatorFollowing?
}

@Repository
class CreatorFollowingQueryRepositoryImpl(
    private val queryFactory: JPAQueryFactory
) : CreatorFollowingQueryRepository {
    override fun findByCreatorIdAndMemberId(creatorId: Long, memberId: Long): CreatorFollowing? {
        return queryFactory
            .selectFrom(creatorFollowing)
            .where(
                creatorFollowing.creator.id.eq(creatorId)
                    .and(creatorFollowing.member.id.eq(memberId))
            )
            .fetchFirst()
    }
}
