package kr.co.vividnext.sodalive.member.stipulation

import kr.co.vividnext.sodalive.common.BaseEntity
import kr.co.vividnext.sodalive.member.Member
import javax.persistence.Entity
import javax.persistence.FetchType
import javax.persistence.JoinColumn
import javax.persistence.ManyToOne

@Entity
data class StipulationAgree(
    val isAgree: Boolean
) : BaseEntity() {
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "member_id", nullable = false)
    var member: Member? = null
        set(value) {
            member?.stipulationAgrees?.add(this)
            field = value
        }

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "stipulation_id", nullable = false)
    var stipulation: Stipulation? = null
}

object StipulationIds {
    const val TERMS_OF_SERVICE_ID = 1L
    const val PRIVACY_POLICY_ID = 2L
}
